﻿-- Priority List 3
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...
local addon = PriorityList

function addon.sortbytime(a, b)
 return a.time < b.time
end

function addon.sort(a, b)
 return a < b
end

local nt       = { [518] = 100, [519] = 80, [520] = 60, [521] = 30, [522] = 15 }
local pt       = { [622] = 3, [623] = 6, [624] = 9, [625] = 12, [626] = 15, [627] = 18, [591] = 20, [628] = 21, [629] = 24,
                   [630] = 27, [631] = 30, [632] = 33, [553] = 35, [633] = 36, [634] = 39, [609] = 40, [635] = 42, [636] = 45,
                   [637] = 48, [638] = 51, [639] = 54, [640] = 57, [641] = 60, [556] = 65, [557] = 70 }
local adjust_t = { [-2] = {519, 609, 635}, [-1] = {519, 632, 637}, [1]  = {520, 634, 591}, [2]  = {520, 609, 627},
                   [3]  = {522, 625}, [4]  = {521, 591, 623}, [5]  = {520, 553, 591}, [6]  = {522, 624}, [7]  = {521, 591, 622},
                   [8]  = {520, 609, 625}, [9]  = {522, 623}, [10] = {521, 591}, [11] = {520, 609, 624}, [12] = {522, 622},
                   [13] = {520, 591, 630}, [14] = {520, 609, 623} }

local counter = 0
local function adjustResult(s, diff, maxBonuses)
 if adjust_t[diff] then
  for k,v in pairs(adjust_t[diff]) do
   if counter < maxBonuses then
    s = s..":"..v
    counter = counter + 1
   end
  end
 end
 
 return s
end

local function getNear(a, b, t, maxBonuses)
 local s = ""

 if (a - b < 15 and a - b > -3) then
  s = adjustResult(s, a - b, maxBonuses)
 else 
  local remaining = -math.abs(a - b)
  while counter < maxBonuses do
   local index
   local last_diff = -10000

   for k,v in pairs(t) do
    local diff = remaining + v
    if diff <= 0 and diff > last_diff then
     index = k
     last_diff = diff
    end
   end

   if index then
    remaining = remaining + t[index]
    s = s..":"..index
   else
    break
   end

   local real_diff = t == pt and last_diff or -last_diff
   if real_diff < 15 and real_diff > -3 then
    s = adjustResult(s, real_diff, maxBonuses)
    break
   end
  
   counter = counter + 1
  end
 end

 return s
end

function addon:setItemlevel(a, b, current_bonuses)
 local s
 counter = 1
 
 if a > b then
  s = getNear(a, b, nt, 15 - current_bonuses)
 elseif a < b then
  s = getNear(a, b, pt, 15 - current_bonuses)
 end

 if not s then counter = 0 end
 
 return s, counter
end